'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _carrack = require('carrack');

var _carrack2 = _interopRequireDefault(_carrack);

var _minimist2 = require('minimist');

var _minimist3 = _interopRequireDefault(_minimist2);

var _deepAssign = require('deep-assign');

var _deepAssign2 = _interopRequireDefault(_deepAssign);

var _utils = require('./utils');

var utils = _interopRequireWildcard(_utils);

var _package = require('../package.json');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } // dependencies


/**
* @extends AsyncEmitter
* @class Abigail
*/

var Abigail = function (_AsyncEmitter) {
  _inherits(Abigail, _AsyncEmitter);

  function Abigail() {
    _classCallCheck(this, Abigail);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(Abigail).apply(this, arguments));
  }

  _createClass(Abigail, [{
    key: 'initialize',


    /**
    * @method initialize
    * @param {array} argv - a command line arguments
    * @param {object} options - a abigail options
    * @returns {abigail} this - the self instance
    */
    value: function initialize(argv) {
      var options = arguments.length <= 1 || arguments[1] === undefined ? { process: process } : arguments[1];

      var _minimist = (0, _minimist3.default)(argv);

      var globs = _minimist._;

      var cliOptions = _objectWithoutProperties(_minimist, ['_']); // eslint-disable-line


      if (cliOptions.version || cliOptions.v || cliOptions.V) {
        options.process.stdout.write(_package.version + '\n');
        options.process.exit(0);
        return this;
      }

      var json = utils.lookupJson(options.cwd || process.cwd());
      var opts = Object.assign({}, this.constructor.defaultOptions || {}, json.options || {});

      var pluginOptions = (0, _deepAssign2.default)({}, utils.resolvePluginOptions(this.constructor.defaultOptions.plugins), utils.resolvePluginOptions(json.options.plugins), utils.resolvePluginOptions(cliOptions));
      var plugins = utils.loadPlugins(this, pluginOptions);

      this.props = { globs: globs, json: json, opts: opts, pluginOptions: pluginOptions, plugins: plugins };

      return this;
    }
    // @static
    // @property defaultOptions

  }]);

  return Abigail;
}(_carrack2.default);

Abigail.defaultOptions = {
  plugins: {
    exit: true,
    launch: true,
    log: true,
    parse: true,
    watch: true
  }
};
exports.default = Abigail;
module.exports = exports['default'];
//# sourceMappingURL=Abigail.js.map